﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion


using System;
using System.Collections.Generic;
using System.Linq;
using HeuristicLab.Services.Hive.DataAccess;
using DT = HeuristicLab.Services.Hive.DataTransfer;
namespace HeuristicLab.Services.Hive {
  public interface IHiveDao {
    #region Task Methods
    Task GetTaskById(Guid id);

    IQueryable<TaskInfoForScheduler> GetWaitingTasks(Slave slave);

    void UpdateTask(Task task);
    void UpdateTaskAndPlugins(Task task);
    Task UpdateTaskState(Guid taskId, TaskState taskState, Guid? slaveId, Guid? userId, string exception);

    #endregion

    #region TaskData Methods
    TaskData GetTaskDataByDto(DT.TaskData dto);
    void UpdateTaskData(TaskData taskData);
    #endregion

    #region StateLog Methods

    #endregion

    #region Job Methods

    #endregion

    #region JobPermission Methods

    #endregion

    #region Plugin Methods

    #endregion

    #region PluginData Methods

    #endregion

    #region Slave Methods
    Slave GetSlaveById(Guid id);

    void UpdateSlave(Slave slave);
    #endregion

    #region SlaveGroup Methods

    #endregion

    #region Resource Methods
    IQueryable<Guid> GetAssignedResourcesIds(Guid taskId);
    IEnumerable<Resource> GetParentResources(Guid resourceId);
    IEnumerable<Guid> GetParentResourcesIDs(Guid resourceId);
    #endregion

    #region ResourcePermission Methods

    #endregion

    #region Authorization Methods

    #endregion

    #region Lifecycle Methods

    #endregion

    #region Downtime Methods
    IQueryable<int> GetNumberOfDowntimesFromParentResourcesAtCurrentTime(Guid resourceId, DowntimeType type);
    #endregion

    #region Statistics Methods

    #endregion

    #region UserPriority Methods

    #endregion
  }
}
